<?php
define("DRSTATS", "1");
        
class Page{
    private $mainView = "";
    
    private $view;
    static private $model;

    static private $mid = 0;
    static private $mapName = "";

    
    public function __construct(){
        require("config.php");
        require("DBConnection.php");
        require("views/view.php");
        require("lang/l12n.php");
        
        require("helpers/helperFlags.php");

        L12N::initialize();
        L12N::setLang($lang);
        if(isset($_GET['lang']))
            L12N::setLang($_GET['lang']);
        
        try{
            DBConnection::connect($host, $user, $pass, $dbname);
        }
        catch(Exception $e){
            die($e->getMessage());
        }

        $ini = parse_ini_file('menu.ini', 1);
        $main;
        foreach($ini as $value){
            $main = isset($value['main']);
            View::addMenuItem( __($value['label']), $value['view'], $main);
            
            if($main)
                $this->mainView = $value['view'];
        }
        
        new View( $this->selectView() );
    }
    public function  __destruct() {
        DBConnection::disconnect();
    }
    private function setView($view){
        $this->view = $view;
    }
    private function selectView(){
        $model = $this->getModel();
        
        if(isset($_GET['page'])){
            $page = preg_replace("/[^a-zA-Z0-9\s]/","", $_GET['page']);
            $this->setView($page);
        }
        else if(isset($_GET['mid'])){
            Page::$mid = intval($_GET['mid']);
       
            Page::$mapName = $model->getMapName(Page::$mid);
            if(Page::$mapName == NULL)
                $this->setView('Error');
            else
                $this->setView('Top');
        }else{
             $this->setView($this->mainView);
        }

         return $this->view;
    }
    static public function getModel($name = 'Default'){
        static $lastModel = '';
        static $models = array();

        if($lastModel != $name){
            if(!isset($models[$name])){
                $modelName = "model{$name}";
                require_once("models/{$modelName}.php");
                $models[$name] = new $modelName();
                Page::$model = $models[$name];
            }
            $lastModel = $name;
        }
        return Page::$model;
    }

    static public function getMid(){
        return Page::$mid;
    }
    static public function getMapName(){
        return Page::$mapName;
    }
};

new Page();
?>
